program SSIRead;

{$IFDEF WINDOWS}
uses synaser,synautil,synaip,blcksock,dos,crt;
var
ser:TBlockSerial;
TheComPort : string;
IPAddr : string;
Socket : TUDPBlockSocket;
{$ELSE}
uses dos,crt;
var TheComPort : word;
{$ENDIF}


{$I SELECTC}
{$I SELECTIO}
{I SELECTP}
{$I SELECTPR}
{$I INTERFCE}

var

BitLength : byte;
Bitrate : real;
SSIBaseClock : real;
BitRateDDS: longint;
SSIBaseAddr: word;
SSINumregs : byte;
SSIDataReg0 : word;
SSIDataReg1 : word;
SSIControlReg : word;
RegStride : word;
InstStride : word;

const

SSIBusyBit : longint = $00000800;

procedure Usage;
begin
  writeln('Usage: SSIREAD BitLength [Bitrate]');
  writeln;
  halt(2);
end;

procedure Error(err : integer);
begin
  writeln(errorrecord[err].errstr);
  halt(2);
end;

procedure GetParms;
var
retcode : integer;
begin
  BitRate := 400000.0; { default SSI bit rate is 400 KHz }
  if ParamCount < 1 then Usage;
  val(ParamStr(1),BitLength,retcode);
  if retcode <> 0 then BumOut('Invalid bit length');
  if BitLength > 64 then  BumOut('Invalid bit length');
  if ParamCount > 1 then
  begin
    val(ParamStr(2),BitRate,retcode);
    if retcode <> 0 then Bumout('Invalid bit rate');
  end;
end;

procedure SetupSSI;
var
index : byte;
begin
  FillHM2Array;
  SSIBaseClock := Read32(HostMotClockLowOffset);
  if not GetModuleInfo(SSITag,SSIBaseAddr,SSINumRegs) then BumOut('No SSI interface found');
  if not GetModuleStrides(SSITag,RegStride,InstStride) then BumOut('No SSI interface found');
  ZeroMasks;
  SetAllHM2OutputMasks;
  for index := 0 to MaxConns -1 do
  begin
    if OutputMasks[index] <> 0 then
    begin
      Write32($1100+index*4,OutputMasks[index]); { ddr }
      Write32($1200+index*4,OutputMasks[index]); { altsource }
    end;
  end;
  BitRateDDS := 65536*round((BitRate*65536)/SSIBaseClock);
  BitRateDDS := BitRateDDS or BitLength or $100;
  SSIDataReg0 := SSIBaseAddr;
  SSIDataReg1 := SSIDataReg0+RegStride;
  SSIControlReg := SSIDataReg1+RegStride;
  Write32(SSIControlReg,BitRateDDS);
end;


function GraytoBin(gray : longint;bitlength: byte) : longint;
var
index : byte;
maskg,maskb,bin : longint;
begin
  maskb := 1 shl (bitlength-1);
  maskg := 1 shl (bitlength-2);
  bin := 0;
  bin := bin or (gray and maskb);
  for index := 1 to bitlength do
  begin
    if ((bin and maskb)  <> 0)  and ((gray and maskg) = 0)
    then bin := bin or maskg;
    if ((bin and maskb)  = 0)  and ((gray and maskg) <> 0)
    then bin := bin or maskg;
    maskg := maskg shr 1;
    maskb := maskb shr 1;
  end;
  GrayToBin := bin;
end;

procedure SSIReadLoop;
var gcts,cts: longint;
begin
  ClrScr;
  while not keypressed do
  begin
    Write32(SSIDataReg0,0);
    while(Read32(SSIControlReg) and SSIBusyBit) <> 0 do;
    GotoXY(1,5);
    gcts := Read32(SSIDataReg0);
    cts := GrayToBin(gcts,BitLength);
    write('Gray: ');
    hexprint(gcts,8);
    write('  Hex: ');
    hexprint(cts,8);
    write('  Dec: ',cts:8,'    ');
  end;
  readkey;
end;

begin
  GetOurEnv;
  if not InitializeInterface(message) then bumout(message);
  if ParamCount < 1 then Usage;
  GetParms;
  SetupSSI;
  SSIReadLoop;
end.
